---------------------------------------------------------------------------------------------------
-- Macroscript declaration:
----------------------------------------------------------------------------------------------------

filein ("$userscripts\\GoMax\\GoMaxZbrushImport.ms");
filein ("$userscripts\\GoMax\\GoMaxZbrushExport.ms");

macroScript GoMax	
category:"Norman3D"
toolTip:"GoMax"
ButtonText:"GoMax"
 
(
		on execute do(
					filein ("$userscripts\\GoMax\\GoMax.ms"); 
		)
)

---------------------------------------------------------------------------------------------------
-- Kill all open dialogs.
----------------------------------------------------------------------------------------------------

fn KillAndLaunchDialog theRollout kill launch=
	(
	if kill do try (	DestroyDialog theRollout; ) catch();
	if launch do createDialog theRollout	
	)
	
KillAndLaunchDialog gomax_about_rollout true false
KillAndLaunchDialog GoMaxButtons true  false
KillAndLaunchDialog gomax_Settings true  false



----------------------------------------------------------------------------------------------------
-- Additional rollout declaration:
----------------------------------------------------------------------------------------------------

rollout gomax_about_rollout "About GoMax" width:250 height:355
(
	label lblAbout "GoMax - Version 2.1"
	group  "Made By" 
		(
		label lblNorman "Norman Schaar - Original Code and Concept"
		hyperlink hlNormanlink "www.norman3d.com"  address:"http://www.norman3d.com" align:#center color: (color 0 0 255)
		label lblBjorn "Bjorn Albihn - Maxscript Support"
		hyperlink hlBjornlink "www.albihn.net"  address:"http:/www.albihn.net" align:#center color: (color 0 0 255)
		)
	group "Additional Thanks"
		(
		label lblnircmdc "Nir Sofer - NirCmd Utility"
		hyperlink lblnircmdclink "www.nirsoft.net" address:"http://www.nirsoft.net/utils/nircmd.html" align:#center color: (color 0 0 255)
		label lblhttpget "DiamondCS - HTTPGet"
		hyperlink lblhttpgetlink "www.diamondcs.com.au" address:"http://www.diamondcs.com.au" align:#center color: (color 0 0 255)
		label lblTill "Till Maginot - Toon/Comic Shader"
		hyperlink lblTilllink "www.blog.maginot.eu" address:"http://blog.maginot.eu" align:#center color: (color 0 0 255)
		label lblTillShader "Shader was build with ShaderFX from Lumonix"
		hyperlink lblTillShaderlink "www.lumonix.net" address:"http://www.lumonix.net/shaderfx.html" align:#center color: (color 0 0 255)
		
		label lblMark "Mark Hancock - Additional Maxscript Support"  
		--hyperlink hlMarklink "www.mark.com"  address:"http://www.mark.com" align:#center color: (color 0 0 255)
			
		label lblzbrushcentral "ZBrushcentral - Thank you guys!"
		hyperlink lblzbrushcentrallink "www.zbrushcentral.com" address:"http://www.zbrushcentral.com" align:#center color: (color 0 0 255)
			
		)
	on gomax_about_rollout open do
		(
				try ( SetDialogPos gomax_about_rollout ((GetDialogPos gomax_about_rollout) + [0,80]) )catch();
		)
)
	


----------------------------------------------------------------------------------------------------
-- Main rollout menu:
----------------------------------------------------------------------------------------------------

rollout GoMaxButtons "GoMax 2.1" 
(
	local zBrushPath =""
	local zBrushPath =""
	local ZBexportbmp = bitmap 100 100 --color:red
	local ZBimportbmp = bitmap 100 100 --color:red
	local launch_Zbrushbmp = bitmap 100 100 --color:red
	local open_matcap_folderbmp = bitmap 100 100 --color:red
	
	----------------------------------------------------------------------------------------------------
	--The GUI:
	----------------------------------------------------------------------------------------------------
		button about_gomax "About" width:60 height:20 pos:[0,0] tooltip:"About GoMax"
		checkbutton pin_gomax width:20 height:20 pos:[60,0] tooltip:"Pin or Unpin GoMax"
		button close_gomax "X" width:20 height:20 pos:[80,0] tooltip:"Close GoMax"
		imgtag ZBexportimg "imgtag" bitmap:ZBexportbmp width:100 height:54 pos:[0,20] tooltip:"Import the active Ztool to Max"
		imgtag ZBimportimg "imgtag" bitmap:ZBimportbmp width:100 height:54 pos:[0,74] tooltip:"Export selected objects to Zbrush, replaces active Ztool"
		imgtag launch_Zbrushimg "imgtag" bitmap:launch_Zbrushbmp width:33 height:33 pos:[0,128] tooltip:"Launches Z-Brush or maximizes it if already open"
		imgtag open_matcap_folderimg "imgtag" bitmap:open_matcap_folderbmp width:33 height:33 pos:[33,128] tooltip:"Open Matcap folder"
		--button open_matcap_folder width:33 height:33 pos:[33,128] tooltip:"Open Matcap folder"
		checkbutton ZB_Settings width:33 height:33 pos:[66,128] tooltip:"Open GoMax Settings Window"

		

	
		fn updateButtons =
		(
			ZBexportimg.bitmap = (openBitmap "$userscripts\\GoMax\\zb_to_max.bmp")
			ZBimportimg.bitmap = (openBitmap "$userscripts\\GoMax\\max_to_zb.bmp")
			launch_Zbrushimg.bitmap = (openBitmap "$userscripts\\GoMax\\launch_Zbrush.bmp")
			open_matcap_folderimg.bitmap = (openBitmap "$userscripts\\GoMax\\matcap_folder.bmp")
			fn check_version= --return which version the user has, 11000 = max2009, 12000 = max 2010
			(
				global ver = maxversion()
				return ver[1]
			)
			global nircmdc = (symbolicPaths.getPathValue "$userscripts" + "\\GoMax\\nircmdc.exe")
			global GomaxPath4DOSCommands = (symbolicPaths.getPathValue "$userscripts" + "\\GoMax\\")
			--nircmdc.exe win -style class "MAXScriptDialog" 0x00080000
			if ((maxVersion())[1] > 9000 ) then
				(
					hiddenDosCommand ("nircmdc.exe elevatecmd win -style title " + "\"" + "GoMax 2.1" + "\"" + " 0x00080000") donotwait:true startpath:(("$userscripts" + "\\GoMax\\") as string)
				)
				else
				(
					shellLaunch ("\"" + GomaxPath4DOSCommands + "nircmdc.exe" + "\"") ("elevatecmd win -style title " + "\"" + "GoMax 2.1" + "\"" + " 0x00080000")
				)
			--set icons
			GoMax_settingsBMP = "$userscripts\\GoMax\\GoMax_Settings.bmp"
			GoMax_pinbutton = "$userscripts\\GoMax\\GoMaxpinbutton.bmp"
				
			ZB_Settings.images = #(GoMax_settingsBMP, undefined, 1,1,1,1,1 )
			pin_gomax.images =  #(GoMax_pinbutton, undefined, 2,1,2,1,1 )
			--set variables
			fSettingsFile = "$userscripts\\GoMax_settings.ini"
			zBrushPath = getINISetting fSettingsFile "Zbrush" "Path" as string
			--Sets the settings if it's a fresh isntall
			if doesFileExist "$userscripts\\GoMax\\FreshInstall.txt" do
			(
				deletefile "$userscripts\\GoMax\\FreshInstall.txt"
				filein ("$userscripts\\GoMax\\GoMaxSettings.ms")
				destroyDialog gomax_Settings
			)
			GoMaxpositionY = getINISetting fSettingsFile "GeneralSettings" "Window Position Y" as float
			GoMaxpositionX = getINISetting fSettingsFile "GeneralSettings" "Window Position X" as float
			SetDialogPos GoMaxButtons [GoMaxpositionX, GoMaxpositionY]
		) 
	
	
    ----------------------------------------------------------------------------------------------------
	--The event handling/logic stuff:
	----------------------------------------------------------------------------------------------------
			on close_gomax pressed do
			(
				KillAndLaunchDialog gomax_about_rollout true false
				KillAndLaunchDialog GoMaxButtons true  false
				KillAndLaunchDialog gomax_Settings true  false
			)
		
		
			on pin_gomax changed theState do 
			(
				if theState == true then
					(
						if ((maxVersion())[1] > 9000 ) then
						(
							--nircmdc.exe elevate win settopmost title "ZBrush" 0  --This removes the always-on-top that zbrush has per default set on
							hiddenDosCommand ("nircmdc.exe elevatecmd win settopmost title " + "\"" + "ZBrush" + "\"" + " 0") donotwait:true startpath:(("$userscripts" + "\\GoMax\\") as string)
							--nircmdc.exe elevate win settopmost title "GoMax" 1  -- This sets the GoMax window to stay on top
							hiddenDosCommand ("nircmdc.exe elevatecmd win settopmost title " + "\"" + "GoMax 2.1" + "\"" + " 1") donotwait:true startpath:(("$userscripts" + "\\GoMax\\") as string)
						)
						else
						(
							shellLaunch ("\"" + GomaxPath4DOSCommands + "nircmdc.exe" + "\"") ("elevatecmd win settopmost title " + "\"" + "ZBrush" + "\"" + " 0")
							shellLaunch ("\"" + GomaxPath4DOSCommands + "nircmdc.exe" + "\"") ("elevatecmd win settopmost title " + "\"" + "GoMax 2.1" + "\"" + " 1")
						)
					)
				else
					(
						if ((maxVersion())[1] > 9000 ) then
						(
							hiddenDosCommand ("nircmdc.exe elevatecmd win settopmost title " + "\"" + "GoMax 2.1" + "\"" + " 0") donotwait:true startpath:(("$userscripts" + "\\GoMax\\") as string)
						)
						else
						(
							shellLaunch ("\"" + GomaxPath4DOSCommands + "nircmdc.exe" + "\"") ("elevatecmd win settopmost title " + "\"" + "GoMax 2.1" + "\"" + " 0")
						)
					)
			)


			on ZB_Settings changed theState2 do 
			(
				if theState2 == true then
				(
				filein ("$userscripts\\GoMax\\GoMaxSettings.ms")
					if ((maxVersion())[1] > 9000 ) then
					(
						hiddenDosCommand ("nircmdc.exe elevatecmd win -style title " + "\"" + "GoMax Settings" + "\"" + " 0x00080000") donotwait:true startpath:(("$userscripts" + "\\GoMax\\") as string)
					)
					else
					(
						shellLaunch ("\"" + GomaxPath4DOSCommands + "nircmdc.exe" + "\"") ("elevatecmd win -style title " + "\"" + "GoMax Settings" + "\"" + " 0x00080000")
					)
				)
				else
				(
				KillAndLaunchDialog gomax_Settings true  false
				)
			)

				
				
			on about_gomax pressed do
				(
					KillAndLaunchDialog gomax_about_rollout true true
				)
				
			--on launch_Zbrush rightclick do shellLaunch (((zbrushpath) as string) + "Zbrush.exe") "" -- start Zbrush when rightclicking! (max 8 and above) /B
			on launch_Zbrushimg click do
				(
					zbrush_exists = ("$userscripts\\GoMax\\zbrush_exists.txt")
					if ((maxVersion())[1] > 9000 ) then
						(
							--nircmdc.exe memdump ZBrush.exe zbrush_exists.txt "32" "0x10000" "0x001"
							HiddenDOSCommand ("nircmdc.exe elevatecmd memdump ZBrush.exe " + "\"" +  ((GomaxPath4DOSCommands) as string)  + "zbrush_exists.txt" + "\"" + " " + "\"" + "32" + "\"" + " " + "\"" + "0x10000" + "\"" + " " + "\"" + "0x001" + "\"") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
						)
						else
						(
							shellLaunch ("\"" + GomaxPath4DOSCommands + "nircmdc.exe" + "\"") ("elevatecmd memdump ZBrush.exe " + "\"" +  ((GomaxPath4DOSCommands) as string)  + "zbrush_exists.txt" + "\"" + " " + "\"" + "32" + "\"" + " " + "\"" + "0x10000" + "\"" + " " + "\"" + "0x001" + "\"")
						)
					--sleep 0.5 --Don't like one bit having to put a "sleep" here, otherwise the txt file is not created in time to do the check! :/
						if doesfileexist zbrush_exists then
						(
							deleteFile zbrush_exists
							if ((maxVersion())[1] > 9000 ) then
							(
								--"nircmdc.exe elevatecmd win max title "ZBrush""
								HiddenDOSCommand ("nircmdc.exe elevatecmd win activate title " + "\"" +  "ZBrush"  + "\"") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
								HiddenDOSCommand ("nircmdc.exe elevatecmd win max title " + "\"" +  "ZBrush"  + "\"") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
							)
							else
							(
								shellLaunch ("\"" + GomaxPath4DOSCommands + "nircmdc.exe" + "\"") ("elevatecmd win activate title " + "\"" +  "ZBrush"  + "\"")
								shellLaunch ("\"" + GomaxPath4DOSCommands + "nircmdc.exe" + "\"") ("elevatecmd win max title " + "\"" +  "ZBrush"  + "\"")
							)
						)
						else
						(
							shellLaunch (((zbrushpath) as string) + "Zbrush.exe") ""
							if ((maxVersion())[1] > 9000 ) then
							(
								HiddenDOSCommand ("nircmdc.exe elevatecmd win max title " + "\"" +  "ZBrush"  + "\"") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
							)
							else
							(
								shellLaunch ("\"" + GomaxPath4DOSCommands + "nircmdc.exe" + "\"") ("elevatecmd win max title " + "\"" +  "ZBrush"  + "\"")
							)
						)
				)

			on open_matcap_folderimg click do
				(
					shellLaunch "explorer.exe"  (((zbrushpath) as string) + "ZStartup\\ZPlugs\\GoMax\\Matcaps\\")
				)
			on ZBimportimg click do
				(
					macros.run "Norman3D" "ZBrush_Import"
				)
			on ZBexportimg click do
				(
					macros.run "Norman3D" "ZBrush_Export"
				)

				
			on GoMaxButtons open do updateButtons()
				
			on GoMaxButtons close do
			(
				fSettingsFile = "$userscripts\\GoMax_settings.ini"
				GoMaxposition = (getDialogPos GoMaxButtons)
				GoMaxpositionY = GoMaxposition.y
				GoMaxpositionX = GoMaxposition.x
				setINISetting fSettingsFile "GeneralSettings" "Window Position Y" (GoMaxpositiony as string)
				setINISetting fSettingsFile "GeneralSettings" "Window Position X" (GoMaxpositionx as string)
			)
)



----------------------------------------------------------------------------------------------------
-- Create the final dialog:
----------------------------------------------------------------------------------------------------
	
createDialog GoMaxButtons width:100 height:160






