rollout gomax_Settings "GoMax Settings" width:340 height:300
(
	local fSettingsFile = "$userscripts\\GoMax_settings.ini"
	 
	GroupBox grpMaterialSettings "Material" pos:[4,100] width:165 height:85
	
	radiobuttons radViewport "Viewport" pos:[12,115] width:74 height:62 labels:#("DirectX", "Standard", "MentalRay") columns:1
	radiobuttons radRender "Render" pos:[90,115] width:76 height:78 labels:#("DirectX", "Standard", "MentalRay") columns:1
	
	GroupBox grpOtherSettings "Other" pos:[170,100] width:165 height:85
	
	checkbox chkUseDialogs "Export/Import with Dialogs" pos:[175,115] width:152 height:16
	checkbox chkAutoUpdate "Auto-Update GoMax" pos:[175,131] checked:true
	
	GroupBox grpZbrushExpSettings "ZBrush -> 3dsMax" pos:[4,0] width:165 height:98
	checkbox chkDiffuse "Diffuse" pos:[12,15] tooltip:"Exports the diffuse map and/or the polypaint"
	checkbox chkNormalMap "Normal Map" pos:[12,31] tooltip:"Exports the normal map"
	checkbox chkDispMap "Disp Map" pos:[12,46] tooltip:"Exports the displacement map"
	checkbox chkMaterial "Matcap" pos:[12,62] checked:true tooltip:"Exports the matcap material"
	checkbox chkSubtools "Subtools" pos:[12,78] checked:true tooltip:"Exports visible subtools"
	
	checkbox chkFixScale "Fix Scale" pos:[92,15] checked:true tooltip:"Fixes a scale issue ZBrush has"
	checkbox chkPolyGroups "Polygroup" pos:[92,31] checked:false tooltip:"Fixes a scale issue ZBrush has" enabled:false
	checkbox chk1stSubDv "1st SDiv" pos:[92,46] checked:false tooltip:"Exports the first subdivision"
	
	GroupBox grp3dsmaxExpSettings "3dsMax -> ZBrush" pos:[170,0] width:165 height:98
	checkbox chkDisableSmooth "Disable Turbo/Meshsmooth" pos:[175,15] tooltip:"Disables Turbo/Meshsmooth when exporting" checked:true
	checkbox chkExportDiffuse "Diffuse" pos:[175,31] tooltip:"Exports the Diffuse map to Zbrush" width:140 height:16 enabled:false checked:false
	checkbox chkCollapseSelection "Collapse Selection" pos:[175,46] tooltip:"Will export the selection as one single mesh" checked:false enabled:false
	checkbox chkImport1stSubDv "Import into 1st SDiv" pos:[175,62] checked:false
	
	
	
	GroupBox grpImportFilesSettings "Relocate GoMax files from Zbrush Directory to:" pos:[4,190] width:330 height:98

	edittext txtFilePath "" pos:[12,206] width:290 height:16 text: "\\GoMaxFiles\\"
	button bnBrowse "Browse" pos:[12,256] width:50 height:24 enabled:false
	button bnExplore "Explore" pos:[62,256] width:50 height:24 toolTip:"Open folder in Windows Explorer"
	checkbox chkRelative "Path is relative to current maxfile" pos:[14,224] width:109 height:32 enabled:true checked:true	
	
	radiobuttons rdObj "Obj" pos:[170,225] width:20 height:46 labels:#("", "") columns:1
	radiobuttons rdDf "Df" pos:[195,225] width:20 height:62 labels:#("", "", "") columns:1
	radiobuttons rdNm "Nm" pos:[220,225] width:20 height:62 labels:#("", "", "") columns:1
	radiobuttons rdDisp "Disp" pos:[245,225] width:20 height:62 labels:#("", "", "") columns:1 
	radiobuttons rdMatcap "MatCap" pos:[270,225] width:20 height:46 labels:#("", "") columns:1

	label lblLabels1 "Ignore" pos:[125,240] width:40 height:16
	label lblLabels2 "Copy" pos:[125,254] width:40 height:16 
	label lblLabels3 "Move" pos:[125,270] width:40 height:16 



	fn fnSaveSettingsToFile=
		(
		-- General settings
		setINISetting fSettingsFile "GeneralSettings" "UseDialogs" (chkUseDialogs.state as string)
		setINISetting fSettingsFile "GeneralSettings" "Auto-Update" (chkAutoUpdate.state as string)
		-- Material settings
		setINISetting fSettingsFile "ImpMaterials" "ViewportMaterial" (radViewport.state as string)
		setINISetting fSettingsFile "ImpMaterials" "RenderMaterial" (radRender.state as string)
		--Zbrush -> 3dsMax
		setINISetting fSettingsFile "Zbrush -> 3dsMax" "Diffuse" (chkDiffuse.state as string)
		setINISetting fSettingsFile "Zbrush -> 3dsMax" "Normal Map" (chkNormalMap.state as string)
		setINISetting fSettingsFile "Zbrush -> 3dsMax" "Disp Map" (chkDispMap.state as string)
		setINISetting fSettingsFile "Zbrush -> 3dsMax" "Matcap" (chkMaterial.state as string)
		setINISetting fSettingsFile "Zbrush -> 3dsMax" "Subtools" (chkSubtools.state as string)
		setINISetting fSettingsFile "Zbrush -> 3dsMax" "Fix Scale" (chkFixScale.state as string)
		setINISetting fSettingsFile "Zbrush -> 3dsMax" "1st SDiv" (chk1stSubDv.state as string)
		--3dsMax -> Zbrush
		setINISetting fSettingsFile "GeneralSettings" "ExportDiffuse" (chkExportDiffuse.state as string)
		setINISetting fSettingsFile "GeneralSettings" "DisableSmoothing" (chkDisableSmooth.state as string)
		setINISetting fSettingsFile "3dsMax -> Zbrush" "Import into 1st SDiv" (chkImport1stSubDv.state as string)
		-- Files settings
		setINISetting fSettingsFile "RelocateFiles" "MatcapFiles" (rdMatcap.state as string)
		setINISetting fSettingsFile "RelocateFiles" "ObjFiles" (rdObj.state as string)
		setINISetting fSettingsFile "RelocateFiles" "DfFiles" (rdDf.state as string)
		setINISetting fSettingsFile "RelocateFiles" "NmFiles" (rdNm.state as string)
		setINISetting fSettingsFile "RelocateFiles" "DispFiles" (rdDisp.state as string)
		setINISetting fSettingsFile "RelocateFiles" "UseRelativePath" (chkRelative.state as string)
		--Relative/Absolute path
		if chkRelative.state == true then setINISetting fSettingsFile "RelocateFiles" "RelativePath" (txtFilePath.text as string)
		else setINISetting fSettingsFile "RelocateFiles" "AbsolutePath" (txtFilePath.text as string)
		-- Check so that Absolute AND relative exists so we dont get a read fail
		absolute_path = getINISetting fSettingsFile "RelocateFiles" "AbsolutePath" as string
		relative_path = getINISetting fSettingsFile "RelocateFiles" "RelativePath" as string
		if absolute_path == "" do setINISetting fSettingsFile "RelocateFiles" "AbsolutePath" "C:\\"
		if relative_path == "" do setINISetting fSettingsFile "RelocateFiles" "RelativePath" "GoMaxFiles\\"
		)
		
	fn fnReadSettingsFromFile=
		(
		if doesfileexist fSettingsFile then
			(
				try
				(
				-- General settings
				chkUseDialogs.state = getINISetting fSettingsFile "GeneralSettings" "UseDialogs" as booleanclass
				chkAutoUpdate.state = getINISetting fSettingsFile "GeneralSettings" "Auto-Update" as booleanclass
				-- Material settings	
				radViewport.state = getINISetting fSettingsFile "ImpMaterials" "ViewportMaterial"  as integer
				radRender.state = getINISetting fSettingsFile "ImpMaterials" "RenderMaterial" as integer
				--Zbrush -> 3dsMax
				chkDiffuse.state = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Diffuse" as booleanclass
				chkNormalMap.state = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Normal Map" as booleanclass
				chkDispMap.state = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Disp Map" as booleanclass
				chkMaterial.state = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Matcap" as booleanclass
				chkSubtools.state = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Subtools" as booleanclass
				chkFixScale.state = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Fix Scale" as booleanclass
				chk1stSubDv.state = getINISetting fSettingsFile "Zbrush -> 3dsMax" "1st SDiv" as booleanclass	
				--3dsMax -> Zbrush
				chkExportDiffuse.state = getINISetting fSettingsFile "GeneralSettings" "ExportDiffuse" as booleanclass
				chkDisableSmooth.state = getINISetting fSettingsFile "GeneralSettings" "DisableSmoothing" as booleanclass
				chkImport1stSubDv.state = getINISetting fSettingsFile "3dsMax -> Zbrush" "Import into 1st SDiv" as booleanclass
				-- Files settings
				rdMatcap.state = getINISetting fSettingsFile "RelocateFiles" "MatcapFiles"   as integer
				rdObj.state = getINISetting fSettingsFile "RelocateFiles" "ObjFiles"  as integer					
				rdDf.state = getINISetting fSettingsFile "RelocateFiles" "DfFiles"  as integer
				rdNm.state = getINISetting fSettingsFile "RelocateFiles" "NmFiles"  as integer				
				rdDisp.state = getINISetting fSettingsFile "RelocateFiles" "DispFiles"   as integer
				--Relative/Absolute path								
				chkRelative.state = getINISetting fSettingsFile "RelocateFiles" "UseRelativePath" as booleanclass
				if chkRelative.state == true then txtFilePath.text = getINISetting fSettingsFile "RelocateFiles" "RelativePath" as string
				else txtFilePath.text = getINISetting fSettingsFile "RelocateFiles" "AbsolutePath" as string			
				)
				catch (fnSaveSettingsToFile())
			)
		else fnSaveSettingsToFile() --else create a new one from the default settings
		)
		
	on gomax_Settings open do with redraw off
	(
	fnReadSettingsFromFile()	
	bnBrowse.enabled = not chkRelative.state
	try ( SetDialogPos gomax_Settings ((GetDialogPos GoMaxButtons) + [120,0]) )catch();
	)
	-- settings that dont include an action in the interface, only save the settings to the ini
	on chkAutoUpdate changed state do fnSaveSettingsToFile()
	on chkUseDialogs changed state do fnSaveSettingsToFile()
	on chkExportDiffuse changed input do fnSaveSettingsToFile()
	on chkDisableSmooth changed input do fnSaveSettingsToFile()
	on radViewport changed state do fnSaveSettingsToFile()
	on radRender changed state do fnSaveSettingsToFile()
	on rdMatcap changed state do fnSaveSettingsToFile()
	on rdObj changed state do fnSaveSettingsToFile()
	on rdDf changed state do fnSaveSettingsToFile()
	on rdNm changed state do fnSaveSettingsToFile()
	on rdDisp changed state do fnSaveSettingsToFile()
	on txtFilePath changed state do fnSaveSettingsToFile()
	--Zbrush -> 3dsMax
	on chkDiffuse changed state do fnSaveSettingsToFile()
	on chkNormalMap changed state do fnSaveSettingsToFile()
	on chkDispMap changed state do fnSaveSettingsToFile()
	on chkMaterial changed state do fnSaveSettingsToFile()
	on chkSubtools changed state do fnSaveSettingsToFile()
	on chkFixScale changed state do fnSaveSettingsToFile()
	on chk1stSubDv changed state do fnSaveSettingsToFile()
	--3dsMax -> Zbrush
	on chkImport1stSubDv changed state do fnSaveSettingsToFile()
	
	
	
	
	-- settings that includes an action in the interface
	
	on chkRelative changed state do
		(
		bnBrowse.enabled = not state
		if chkRelative.state == true then txtFilePath.text = getINISetting fSettingsFile "RelocateFiles" "RelativePath" as string
		else txtFilePath.text = getINISetting fSettingsFile "RelocateFiles" "AbsolutePath" as string		
		fnSaveSettingsToFile()
		)
		
	on bnBrowse pressed do 
		(
			fNewPath =  getSavePath caption: "Select Folder to store Gomax Files" initialdir: txtFilePath.text
			if fNewPath != undefined do txtFilePath.text = fNewPath
			fnSaveSettingsToFile()
		)
		
	on bnExplore pressed do 
		(
		fpath = getINISetting fSettingsFile "RelocateFiles" "AbsolutePath" as string	
		if chkRelative.state == true then 
			(
			fpath = maxFilePath + (getINISetting fSettingsFile "RelocateFiles" "RelativePath" as string)
			)
		shelllaunch fpath ""
		)
	
)
	
createdialog gomax_Settings