
macroScript ZBrush_Export
category:"Norman3D" 
tooltip:"From ZBrush"
ButtonText: "GoMax From ZBrush"
icon:#("gomaxfromZB",1)
 

(

	-- SETUP
	
	fSettingsFile = "$userscripts\\GoMax_settings.ini"
	zBrushPath = getINISetting fSettingsFile "Zbrush" "Path" as string
	
	
----------------------------------------------------------------------------------------------------
-- Settings txts for Zbrush
----------------------------------------------------------------------------------------------------
	
fn create_settings_txt=
(
	for f in getFiles (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\*.*") do deleteFile f --Cleans up all the files in the Settings folder
	for f in getFiles "$userscripts\\GoMax\\Settings\\*.*" do deleteFile f
	global bDiffuse = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Diffuse" as booleanclass
	global bNormalMap = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Normal Map" as booleanclass
	global bDispMap = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Disp Map" as booleanclass
	global bMaterial = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Matcap" as booleanclass
	global bSubtools = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Subtools" as booleanclass
	global bFixScale = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Fix Scale" as booleanclass
	global b1stSubDv = getINISetting fSettingsFile "Zbrush -> 3dsMax" "1st SDiv" as booleanclass
	global bImport1stSubDv = getINISetting fSettingsFile "3dsMax -> Zbrush" "Import into 1st SDiv" as booleanclass

	
	if ((maxVersion())[1] == 9000 )do
	(
		createFile "$userscripts\\GoMax\\Settings\\3dsmax9.txt"
		close (createFile "$userscripts\\GoMax\\Settings\\3dsmax9.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\3dsmax9.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\3dsmax9.txt")
	)
	
	if bImport1stSubDv == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\Import1stSubDv.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\Import1stSubDv.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\Import1stSubDv.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\Import1stSubDv.txt")
	)	
	
	if b1stSubDv == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\1stSubDv.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\1stSubDv.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\1stSubDv.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\1stSubDv.txt")
	)
	
	if bDiffuse == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\Diffuse.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\Diffuse.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\Diffuse.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\Diffuse.txt")
	)
	if bNormalMap == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\NormalMap.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\NormalMap.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\NormalMap.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\NormalMap.txt")
	)
	if bDispMap == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\DispMap.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\DispMap.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\DispMap.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\DispMap.txt")
	)
	if bMaterial == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\Material.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\Material.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\Material.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\Material.txt")
	)
	if bSubtools == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\Subtools.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\Subtools.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\Subtools.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\Subtools.txt")
	)
	if bFixScale == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\FixScale.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\FixScale.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\FixScale.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\FixScale.txt")
	)

)
	
	
	
	--This checks for material.txt where the name of the material is saved, so that the script know which material it has to apply /Norman

		
/*-----------------------------------------
	FUNCTIONS 
-------------------------------------------*/
	
	fn fnGetMatCapFromTxt TxtFile =
		(
		material_name = "None" -- to avoid crash
		if doesFileExist TxtFile  do
				(
				readFileStream = openFile TxtFile mode:"r"
				if ((maxVersion())[1] == 9000 )then
					(
						material_name = (((readLine readFileStream) as string) + "BMP")
					)
					else
					(
						material_name = (((readLine readFileStream) as string) + "PSD")
					)
				close readFileStream
				material_name =  (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Matcaps\\" + material_name)
				)
		return material_name
		)		
	fn tryToKillFile the_filename=(if doesfileexist the_filename do deletefile the_filename) --deletes file from disk
	fn tryToKillFiles the_filename the_extensions= --deletes files from disk
		(
			for i in the_extensions do
				(
				the_file = the_filename + "." + i 
				if doesfileexist the_file do deletefile the_file
				)
		) 
		
		
/*-----------------------------------------
	SETTINGS SETUP
-------------------------------------------*/

		struct ImportSettings --struct containing all the settings for the import files, expand as necessary /Bjorn
	(
	maxVer, --Maxversion
	bUseDialogs, iViewportMaterial, iRenderMaterial,
	iRelocateMatcap, iRelocateObj, iRelocateDiffuse, iRelocateNormal, iRelocateDisp, sRelocatePath, 
	importINI, -- ini file for ObjImport 
		
		fn loadFromIni fSettingsFile=
		(
			maxVer = (maxVersion())[1] --get max version
			-- load settings from INI
			if doesfileexist fSettingsFile do
				(
					bUseDialogs = getINISetting fSettingsFile "GeneralSettings" "UseDialogs" as booleanclass
					iViewportMaterial= getINISetting fSettingsFile "ImpMaterials" "ViewportMaterial"  as integer
					iRenderMaterial = getINISetting fSettingsFile "ImpMaterials" "RenderMaterial" as integer
					iRelocateMatcap = getINISetting fSettingsFile "RelocateFiles" "MatcapFiles"   as integer
					iRelocateObj = getINISetting fSettingsFile "RelocateFiles" "ObjFiles"  as integer					
					iRelocateDiffuse = getINISetting fSettingsFile "RelocateFiles" "DfFiles"  as integer
					iRelocateNormal= getINISetting fSettingsFile "RelocateFiles" "NmFiles"  as integer				
					iRelocateDisp= getINISetting fSettingsFile "RelocateFiles" "DispFiles"   as integer	
					--Get Relocation Path
					local bRelative = getINISetting fSettingsFile "RelocateFiles" "UseRelativePath" as booleanclass
					if bRelative == true then 	
						(
						sRelocatePath = maxFilePath
						if sRelocatePath == "" and (iRelocateMatcap+iRelocateObj+iRelocateDiffuse+iRelocateNormal+iRelocateDisp) > 5 then --if any is triggered and file is not saved do prompt for save
							(
							sRelocatePath = undefined
							local bAnswer	= queryBox "You have selected to relocate GoMaxFiles to a path relative to your currently open maxfile. Do you want to save your file now? (If not saved, file relocation will be disabled!)"
							if bAnswer == true then 
								(
								local sRelocatePath = getMAXSaveFileName()
								if sRelocatePath != undefined do
									(
									sRelocatePath = (getfilenamepath (sRelocatePath) + (getINISetting fSettingsFile "RelocateFiles" "RelativePath" as string))
									)
								)
							)
						else
							(
								sRelocatePath = maxFilePath + (getINISetting fSettingsFile "RelocateFiles" "RelativePath" as string) 
							)
						)
					else sRelocatePath = getINISetting fSettingsFile "RelocateFiles" "AbsolutePath" as string	
				)
			--setup ObjImporter
			if maxVer >= 12000 do 
				(
				importINI = objImp.getIniName()
				setIniSetting importINI "General" "UseLogging" "0"
				setIniSetting importINI "General" "Preset" ""
				setIniSetting importINI "General" "ResetScene" "0"
				setIniSetting importINI "General" "UseLogging" "0"
				setIniSetting importINI "Objects" "SingleMesh" "1"
				setIniSetting importINI "Objects" "AsEditablePoly" "0"
				setIniSetting importINI "Objects" "Retriangulate" "0"
				setIniSetting importINI "Geometry" "FlipZyAxis" "1"
				setIniSetting importINI "Geometry" "CenterPivots" "0"
				setIniSetting importINI "Geometry" "Shapes" "0"
				setIniSetting importINI "Geometry" "TextureCoords" "1"
				setIniSetting importINI "Geometry" "SmoothingGroups" "1"
				setIniSetting importINI "Geometry" "NormalsType" "0"
				setIniSetting importINI "Geometry" "FlipNormals" "0"
				setIniSetting importINI "Geometry" "ObjScale" "1.000000"
				setIniSetting importINI "Units/Scale" "Convert" "0"
				setIniSetting importINI "Units/Scale" "ObjScale" "1.000000"
				setIniSetting importINI "Material" "UniqueWireColor" "1"
				setIniSetting importINI "Material" "ImportMaterials" "0"
				) 
		)
	)		
		
/*-----------------------------------------
	MATERIAL SETUP
-------------------------------------------*/

		
struct ImportMaterial --  A struct containg everything concerning materials
	(
	sName, --name
	fTheMatcapFile, fTheDiffuseMapFile, fTheNormalMapFile, fTheDispMapFile, --files
	strImportSettings, --settings file
				
			fn STDmaterialsetup= --Standard material setup --  Matcap not included yet, any suggestions on to how to do this in scanline? :)
				(
					local mTheMaterial = standardmaterial name: (sName + "_STDMaterial")
						if bDiffuse == true do
						(
							if doesFileExist fTheDiffuseMapFile  do
								(
								mTheMaterial.DiffuseMap = BitmapTexture filename: fTheDiffuseMapFile
								mTheMaterial.diffuseMapEnable = on
								)
						)
						if bNormalMap == true do
						(
							if doesfileexist  fTheNormalMapFile do
								(
								mTheMaterial.bumpMapEnable = on
								mTheMaterial.bumpMapAmount = 100
								mTheMaterial.BumpMap = Normal_Bump flipgreen:true
								mTheMaterial.BumpMap.normal_map = BitmapTexture filename: fTheNormalMapFile
								)
						)
						if bDispMap == true do
						(
							if doesfileexist fTheDispMapFile do	
								(
								mTheMaterial.DisplacementMap = BitmapTexture filename: fTheDispMapFile
								mTheMaterial.displacementMapEnable = on
								)
						)
					return mTheMaterial
				),

			fn MRmaterialsetup= --mental ray material setup, after the material found in the maxfile.
				(
				if strImportSettings.MaxVer >= 11000 then --add MR material if possible
						(
							mMaterial = mental_ray()
							mMaterial.name = (sName + "_MRMaterial" )
							sphere_map_material = undefined; bitmap_material = undefined;

							if doesFileExist fTheMatcapFile do	sphere_map_material = Environment_Probe_Gray_Ball__mi texture: fTheMatcapFile
							if bDiffuse == true do
							(
								if doesFileExist fTheDiffuseMapFile  do bitmap_material = BitmapTexture filename: fTheDiffuseMapFile
							)

							mMaterial.Surface = compositeMap()
							mMaterial.Surface.add()
							mMaterial.Surface.blendMode = #(0, 5) --base normal, top multiply
							mMaterial.Surface.mapList = #(sphere_map_material,bitmap_material)
							if bNormalMap == true do
							(
								if doesfileexist  fTheNormalMapFile do
									(
									if strImportSettings.MaxVer > 12000 then --this one does not work, but at least it doesnt crash :/  //This has to be >12000 (Above 3dsMax 2010) instead of >=12000
										(
										mMaterial.Bump = Normals_Make_Normal ()
										mMaterial.Bump.Color_shader  = Normal_Bump flipgreen:true
										mMaterial.Bump.Color_shader.normal_map = BitmapTexture filename: fTheNormalMapFile
										)
									else
										(
										mMaterial.Bump = max_Bump() -- this is the one for version bellow 13000
										mMaterial.Bump.Map = Normal_Bump flipgreen:true
										mMaterial.Bump.Map.normal_map = BitmapTexture filename: fTheNormalMapFile
										)										
									)
							)
							if bDispMap == true do
							(
								if doesfileexist fTheDispMapFile do
									(
									mMaterial.Displacement = max_HeightMapDisplacement()
									mMaterial.Displacement.heightMap = BitmapTexture filename: fTheDispMapFile
									mMaterial.Displacement.maxHeight = 5
									mMaterial.Displacement.minHeight = -5
									)
							)								
						)
				else 		--else return a standard material
						(
						mMaterial = STDmaterialsetup()
						)
					return mMaterial
				),
				
			fn DX9materialsetup= --DX9 material setup.
				(
					mMaterial = DirectX_9_Shader () -- create a individual material for each object imported
					mMaterial.name = (sName + "_DX9Material")
					mMaterial.effectFile = "$userscripts\\GoMax\\Material\\mgto_technique_nm_057.FX" --new material
					mMaterial.renderMaterial = undefined
					mMaterial.technique = 2 --new zbrush technique /norman
					mMaterial.DiffuseToAmbient = 0
					mMaterial.DiffuseColour = color 255 255 255 0 --This will display the material properly if no diffuse texture is found, but the value is ignored if there is a diffuse map /Norman

					if doesFileExist fTheMatcapFile do 
							(
							mMaterial.UseLitSphere = on
							mMaterial.LitSphere_Strength = 0.5
							mMaterial.LitSphere = openbitmap  fTheMatcapFile
							)

					if bNormalMap == true then
					(
						if doesFileExist fTheNormalMapFile do
							(
							mMaterial.UseNormalMap = on
							mMaterial.NormalMap = openbitmap fTheNormalMapFile
							)
					)
					else
						(mMaterial.UseNormalMap = off)
					
					if bDiffuse == true then
					(
						if doesFileExist fTheDiffuseMapFile do
							(
							mMaterial.UseDiffuseMap = on
							mMaterial.DiffuseMap = openbitmap fTheDiffuseMapFile
							)
					)
					else
						(mMaterial.UseDiffuseMap = off)
					return mMaterial	
				),

			fn CreateMaterial= --material setup in a function, allows for multiple materials
				(
					case strImportSettings.iViewportMaterial of
						(
						2: mMaterial = STDmaterialsetup()
						3: mMaterial = MRmaterialsetup ()
						default: mMaterial = DX9materialsetup()
						)				
					
					if strImportSettings.iRenderMaterial != strImportSettings.iViewportMaterial do -- If the render material is other than viewport, Shell is created
						(
						mShellMaterial =	Shell_Material originalMaterial: mMaterial viewportMtlIndex: 0 renderMtlIndex: 1 name: (sName + "_ShellMaterial")				
							case strImportSettings.iRenderMaterial of
									(
									2: mShellMaterial.bakedmaterial = STDmaterialsetup()
									3: mShellMaterial.bakedmaterial = MRmaterialsetup ()
									default: mShellMaterial.bakedmaterial =  DX9materialsetup()
									)	
						mMaterial = mShellMaterial 
						)
						
					-- if only OBJ is exported, create standard material.
					if (doesfileexist fTheMatcapFile) == false and (bDiffuse) == false and(bNormalMap) == false do 
						(
						mMaterial = STDmaterialsetup()
						)
						
					Meditmaterials[24] = mMaterial 	--add to slot 24
					return mMaterial
				)
	)		
/*-----------------------------------------
	Import
-------------------------------------------*/
		
struct ImportObject -- A struct containg everything concerning the imported ztool. Currently generated from a filename ie. the object file /Bjorn
	(
	sName, --sName
	fTheObjFile, fTheMatcapFile, fTheDiffuseMapFile, fTheNormalMapFile, fTheDispMapFile, -- all the files
	strImportSettings, --settings file
		
	fn setupFromFilename sTheFilename= 		-- set the initial location of all the properties
		(
			fTheObjFile = (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Export\\" + (getFilenameFile sTheFilename) + ".OBJ")
			fTheMatcapFile = fnGetMatCapFromTxt (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Matcaps\\material.txt")
			if ((maxVersion())[1] == 9000 )then
				(
					fTheDiffuseMapFile =  (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Bitmaps\\" + (getFilenameFile sTheFilename) + ".D.BMP")
					fTheNormalMapFile =  (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Bitmaps\\" + (getFilenameFile sTheFilename) + ".N.BMP")
				)
				else
				(
					fTheDiffuseMapFile =  (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Bitmaps\\" + (getFilenameFile sTheFilename) + ".D.PSD")
					fTheNormalMapFile =  (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Bitmaps\\" + (getFilenameFile sTheFilename) + ".N.PSD")
				)
			fTheDispMapFile =  (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Bitmaps\\" + (getFilenameFile sTheFilename) + ".Disp.Tif")	
		),

	fn copyMoveFile iCase fFile fTargetDir = -- small function to make the code cleaner, used in copyAndRemapFiles only
		(
		local fTarget= (fTargetDir + (filenameFromPath fFile))
		case iCase of
			(
			2:  (
					makedir fTargetDir all:true
					deletefile fTarget
					copyfile fFile fTarget
					return fTarget
				)
			3: (
					makedir fTargetDir all:true
					deletefile fTarget -- overwrites files by default, check for this needed Norman?
					renamefile fFile fTarget
					return fTarget
				)
			default: return fFile
			)
		),		
		
	fn copyAndRemapFiles= --move and remap everything
		(
		if strImportSettings.sRelocatePath != undefined do
			(
			fTheDiffuseMapFile = copyMoveFile strImportSettings.iRelocateDiffuse fTheDiffuseMapFile (strImportSettings.sRelocatePath + "Maps//")
			fTheNormalMapFile = copyMoveFile strImportSettings.iRelocateNormal fTheNormalMapFile (strImportSettings.sRelocatePath + "Maps//")
			fTheDispMapFile = copyMoveFile strImportSettings.iRelocateDisp fTheDispMapFile (strImportSettings.sRelocatePath + "Maps//")			
			fTheMatcapFile = copyMoveFile strImportSettings.iRelocateMatcap fTheMatcapFile (strImportSettings.sRelocatePath + "Material//")			
			fTheObjFile = copyMoveFile strImportSettings.iRelocateObj fTheObjFile (strImportSettings.sRelocatePath + "Obj//")		
			)			
		),	
		
	fn import = --Import fTheObjFile to max.
		(
		local imp	
		if strImportSettings.bUseDialogs != true then imp = importFile fTheObjFile #noPrompt using:ObjImp
		else imp = importFile fTheObjFile using:ObjImp
		if imp = true do 
			(
			local strMaterial = ImportMaterial sName: sName strImportSettings: strImportSettings fTheMatcapFile:fTheMatcapFile fTheDiffuseMapFile:fTheDiffuseMapFile fTheNormalMapFile:fTheNormalMapFile fTheDispMapFile:fTheDispMapFile
			local mMaterial = strMaterial.CreateMaterial()
			for o in selection do -- to all objects imported 
				(
				converttopoly o --See thread: http://www.pixolator.com/showpost.php?p=652540&postcount=12
				o.material =  mMaterial
				)
			)		
		)
	)
		
		
	
	fn uberfetch the_file = --new uberfetch with a updating bar and cancel button. /bjorn
		(
			st = timeStamp()
			i =  0; fetchfile = false; NotCancelled = true
			progressStart "Awaiting Zbrush Export to finish"
		while fetchfile == false and NotCancelled do (
			if timestamp() > (st+(i*100)) do --try to import the file every 0.1 seconds
				(
				i+=1
				NotCancelled = (progressUpdate (i)) 
				fetchfile = doesfileexist the_file
				if i > 100 do ( st = timeStamp(); i = 0; )  --reset the time and progressbar every ten seconds
				)
			)
		progressEnd()
		return NotCancelled -- returns a false if the user pressed cancel, true if the fetch file is found
		)

	fn multiImport strImportSettings=
		(
		file_arr = getFiles (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Export\\" + "*.OBJ") --get all objects to be imported, multiple objects supported.
		for f in file_arr do -- do for every obj file.
			(
			--Setup ImportObjects and Import
			strImportObject = ImportObject strImportSettings:strImportSettings sname: ((getFilenamePath f) + (getFilenameFile f))  --setup the object 
			strImportObject.setupFromFilename f -- get data from the filename
			strImportObject.copyAndRemapFiles()
			strImportObject.import()--import the object
			-- delete to make way for next import.
			tryToKillFiles strImportObject.sName #("OBJ","MTL","BMP") -- kill obj, mtl and bmp
			)
		)
	
	on execute do
	(
			--create Settings txt files
			create_settings_txt()
			-- Cleanup (just to make sure)
			tryToKillFile (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Export\\fetch.txt") -- kill fetch.txt
			--Setup 
			strImportSettings = ImportSettings()
			strImportSettings.loadFromIni fSettingsFile
			-- Export active tools from zbrush, generates fetch.txt
			if (strImportSettings.MaxVer > 9000 ) then
				(
					--The following seems to be slightly faster than runnig the bat file... since I can run certain lines at the same time./Norman
					HiddenDOSCommand ("nircmdc.exe elevatecmd win activate title " + "\"" + "ZBrush" + "\"") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
					HiddenDOSCommand ("nircmdc.exe elevatecmd win max title " + "\"" + "ZBrush" + "\"") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
					HiddenDOSCommand ("nircmdc.exe elevatecmd sendkey shift down") donotwait:true startpath:(("$userscripts" + "\\GoMax\\") as string)
					HiddenDOSCommand ("nircmdc.exe elevatecmd sendkey alt down") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
					HiddenDOSCommand ("nircmdc.exe elevatecmd sendkey E down") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
					HiddenDOSCommand ("nircmdc.exe elevatecmd sendkey shift up") donotwait:true startpath:(("$userscripts" + "\\GoMax\\") as string)
					HiddenDOSCommand ("nircmdc.exe elevatecmd sendkey alt up") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
					HiddenDOSCommand ("nircmdc.exe elevatecmd sendkey E up") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
					HiddenDOSCommand ("nircmdc.exe elevatecmd win min title " + "\"" + "ZBrush" + "\"") donotwait:true startpath:(("$userscripts" + "\\GoMax\\") as string)
					HiddenDOSCommand ("nircmdc.exe elevatecmd win max ititle " + "\"" + "Autodesk 3ds Max" + "\"") donotwait:true startpath:(("$userscripts" + "\\GoMax\\") as string)
				)
				else
				(
					--shellLaunch ("\"" + GomaxPath4DOSCommands + "nircmdc.exe" + "\"") ("elevatecmd exec hide " + "\"" + GomaxPath4DOSCommands + "zb_to_max.bat" + "\"")
					shellLaunch ("$userscripts\\GoMax\\zb_to_max.bat") ""
				)
			-- Import the output into max
			imp= uberfetch (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Export\\fetch.txt") -- when fetch file is found, do import
			if imp == true do with redraw off --only proceed if fetch file is found
				(
				if selection.count != 0 then-- checks if any object is selected before importing, gives a message if you want to replace the object to avoid an non undoable deleting /bjorn
						(
						if queryBox "Do you want to replace your selection with current Zbrush tool?" beep:false then delete selection
						)					
				multiImport strImportSettings -- new function that imports everything in the Files folder, multiple objects support.
				gc() --clean garbage collection to free up memory
				)
			-- Cleanup
			tryToKillFile (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Export\\fetch.txt") -- kill fetch.txt so we can get a new file
			tryToKillFile (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Matcaps\\material.txt")  -- kill material.txt so material is reset
	)
)
	