	
macroScript ZBrush_Import
category:"Norman3D" 
tooltip:"To ZBrush"
ButtonText: "GoMax To ZBrush"
icon:#("gomax2ZB",1)

(
	fSettingsFile = "$userscripts\\GoMax_settings.ini"
	zBrushPath = getINISetting fSettingsFile "Zbrush" "Path" as string
	
	fn check_version= --return which version the user has, 11000 = max2009, 12000 = max 2010
	(
		ver = maxversion()
		return ver[1]
	)
 
----------------------------------------------------------------------------------------------------
-- Settings txts for Zbrush
----------------------------------------------------------------------------------------------------
	
fn create_settings_txt=
(
	for f in getFiles (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\*.*") do deleteFile f --Cleans up all the files in the Settings folder
	for f in getFiles "$userscripts\\GoMax\\Settings\\*.*" do deleteFile f
	global bDiffuse = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Diffuse" as booleanclass
	global bNormalMap = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Normal Map" as booleanclass
	global bDispMap = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Disp Map" as booleanclass
	global bMaterial = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Matcap" as booleanclass
	global bSubtools = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Subtools" as booleanclass
	global bFixScale = getINISetting fSettingsFile "Zbrush -> 3dsMax" "Fix Scale" as booleanclass
	global b1stSubDv = getINISetting fSettingsFile "Zbrush -> 3dsMax" "1st SDiv" as booleanclass	
	global bImport1stSubDv = getINISetting fSettingsFile "3dsMax -> Zbrush" "Import into 1st SDiv" as booleanclass
	
	if ((maxVersion())[1] == 9000 )do
	(
		createFile "$userscripts\\GoMax\\Settings\\3dsmax9.txt"
		close (createFile "$userscripts\\GoMax\\Settings\\3dsmax9.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\3dsmax9.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\3dsmax9.txt")
	)
	
	if bImport1stSubDv == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\Import1stSubDv.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\Import1stSubDv.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\Import1stSubDv.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\Import1stSubDv.txt")
	)	
	
	if b1stSubDv == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\1stSubDv.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\1stSubDv.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\1stSubDv.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\1stSubDv.txt")
	)
	
	if bDiffuse == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\Diffuse.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\Diffuse.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\Diffuse.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\Diffuse.txt")
	)
	if bNormalMap == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\NormalMap.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\NormalMap.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\NormalMap.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\NormalMap.txt")
	)
	if bDispMap == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\DispMap.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\DispMap.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\DispMap.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\DispMap.txt")
	)
	if bMaterial == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\Material.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\Material.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\Material.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\Material.txt")
	)
	if bSubtools == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\Subtools.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\Subtools.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\Subtools.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\Subtools.txt")
	)
	if bFixScale == true do
	(
		createFile  "$userscripts\\GoMax\\Settings\\FixScale.txt"
		close (createFile  "$userscripts\\GoMax\\Settings\\FixScale.txt")
		copyFile ("$userscripts\\GoMax\\Settings\\FixScale.txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Settings\\FixScale.txt")
	)
)
	
	struct ExportObject 
		(object,name,material,
			fn exportAndDelete =
				(
				bUseDialogs = getINISetting fSettingsFile "GeneralSettings" "UseDialogs" as booleanclass
				bDisableSmoothing = getINISetting fSettingsFile "GeneralSettings" "DisableSmoothing" as booleanclass
				/*here I'll disable mesh/turbosmooth*/
				/*here material (diffuse) will be exported*/
				--export the object
				select object
				if bUseDialogs == true then
				(
					exportFile (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Import\\" + name + ".OBJ") selectedOnly:true using:ObjExp
					renameFile ("$userscripts\\GoMax\\Settings\\" + name + ".OBJ") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Import\\" + name + ".OBJ")
				)
				else
				(
					exportFile (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Import\\" + name + ".OBJ") #noPrompt selectedOnly:true using:ObjExp
					renameFile ("$userscripts\\GoMax\\Settings\\" + name + ".OBJ") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Import\\" + name + ".OBJ")
				)
				--delete the object
				delete object --deletes the copied meshes to clean up the scene
				)
		)
	
	struct ExportObjects
	(aExportObjects =#(),
	fn createFromSelection = 
		(
		aExportObjects = #() --make sure array is empty before beginning
		for o in $selection where superclassof o == GeometryClass do
			(
				--Thanks Mark for this piece of script ;)
				CopyMesh = snapshot o													--snapshots the original mesh	//Faster, more secure. / Bjorn
				xformbox = editable_mesh name: (o.name) pos: [0,0,0]			--creates an empty editmesh container
				ConvertToPoly xformbox													-- converts the empty editmesh to editpoly
				xformbox.attach CopyMesh xformbox									--attaches the copied mesh to the empty edit poly, this basically resets the xform and sorts any scaling issues
				--Append to arrays, Get material too
				newExportObject = ExportObject name: o.name object: xformbox material: o.material
				append aExportObjects newExportObject 
			)
		),
	fn exportAndDelete =
		(
		--clean directory
		for f in getFiles (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Import\\*.*") do deleteFile f --Cleans up all the files in the Import folder
		for f in getFiles "$userscripts\\GoMax\\Settings\\*.*" do deleteFile f	
		-- loop through aExportObjects
		for i = 1 to aExportObjects.count do
			(

			--export the objects
			aExportObjects[i].exportAndDelete()
			--write object name into txt file
			fObjInfoFile =createFile  ("$userscripts\\GoMax\\Settings\\obj_name_" + (i as string) +".txt")
			format aExportObjects[i].name to: fObjInfoFile
			close fObjInfoFile
			copyFile ("$userscripts\\GoMax\\Settings\\obj_name_" + (i as string) +".txt") (zbrushpath + "ZStartup\\ZPlugs\\GoMax\\Import\\obj_name_" + (i as string) +".txt")
				
			)
		)
	)
	
	
	on execute do
	(
			--create Settings txt files
			create_settings_txt()
			if selection.count != 0 then -- checks if any object is selected before exporting to avoid any crashing /Bjorn
			(
				ver = check_version()
				if ver >= 12000 do -- objsettings not used in max 2010, however you must setup your OBJexport and import correctly yourself. Check above values.
				(
					theINI = objExp.getIniName()
					setIniSetting theINI "General" "UseLogging" "0"
					setIniSetting theINI "General" "Preset" ""
					setIniSetting theINI "General" "MapSearchPath=" ""
					setIniSetting theINI "Geometry" "FlipZyAxis" "1"
					setIniSetting theINI "Geometry" "Shapes" "0"
					setIniSetting theINI "Geometry" "ExportHiddenObjects" "0"
					setIniSetting theINI "Geometry" "FaceType" "1"
					setIniSetting theINI "Geometry" "TextureCoords" "1"
					setIniSetting theINI "Geometry" "Normals" "1"
					setIniSetting theINI "Geometry" "SmoothingGroups" "1"
					setIniSetting theINI "Geometry" "ObjScale" "1.000000"
					setIniSetting theINI "Material" "UseMaterial" "0"
					setIniSetting theINI "Material" "CreateMatLibrary" "0"
					setIniSetting theINI "Output" "RelativeIndex" "0"
					setIniSetting theINI "Output" "Target" "0"
					setIniSetting theINI "Output" "Precision" "6"
					setIniSetting theINI "Optimize" "optVertex" "0"
					setIniSetting theINI "Optimize" "optNormals" "0"
					setIniSetting theINI "Optimize" "optTextureCoords" "0"
				) 
				--get selection
				aSelectedMeshes = selection as array
				--create Exportobjects and export them
				newExportObjects = ExportObjects()
				newExportObjects.createFromSelection()
				newExportObjects.exportAndDelete()
				--run Gomax commands
					if ver > 9000  then
						(
							HiddenDOSCommand ("nircmdc.exe elevatecmd win activate title " + "\"" + "ZBrush" + "\"") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
							HiddenDOSCommand ("nircmdc.exe elevatecmd win max title " + "\"" + "ZBrush" + "\"") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
							HiddenDOSCommand ("nircmdc.exe elevatecmd sendkey shift down") donotwait:true startpath:(("$userscripts" + "\\GoMax\\") as string)
							HiddenDOSCommand ("nircmdc.exe elevatecmd sendkey alt down") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
							HiddenDOSCommand ("nircmdc.exe elevatecmd sendkey R down") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
							HiddenDOSCommand ("nircmdc.exe elevatecmd sendkey shift up") donotwait:true startpath:(("$userscripts" + "\\GoMax\\") as string)
							HiddenDOSCommand ("nircmdc.exe elevatecmd sendkey alt up") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
							HiddenDOSCommand ("nircmdc.exe elevatecmd sendkey R up") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
							HiddenDOSCommand ("nircmdc.exe elevatecmd win activate title " + "\"" + "ZBrush" + "\"") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
							HiddenDOSCommand ("nircmdc.exe elevatecmd win max title " + "\"" + "ZBrush" + "\"") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
							HiddenDOSCommand ("nircmdc.exe elevatecmd win dlgclick title " + "\"" + "Import Mesh" + "\"" + " yes") donotwait:true startpath:(("$userscripts" + "\\GoMax\\") as string)
							HiddenDOSCommand ("nircmdc.exe elevatecmd win max title " + "\"" + "ZBrush" + "\"") donotwait:false startpath:(("$userscripts" + "\\GoMax\\") as string)
						)
					else
						(
							--shellLaunch ("\"" + GomaxPath4DOSCommands + "nircmdc.exe" + "\"") ("elevatecmd exec hide " + "\"" + GomaxPath4DOSCommands + "max_to_zb.bat" + "\"")
							shellLaunch ("$userscripts\\GoMax\\max_to_zb.bat") ""
						)
				-- select meshes
				select aSelectedMeshes
				gc() --free up memory
				)
			else messagebox "No objects selected" --Gives a message that there is no object selected  /Bjorn	
	)
)
