try (--close if possible
	DestroyDialog gomax_Settings;
) catch();

try (--close if possible
	DestroyDialog PickZBdir;
) catch();

try (--close if possible
	DestroyDialog gomax_install_results;
) catch();

try (--close if possible
	DestroyDialog GoMaxButtons;
) catch();

global GoMaxfolder = (symbolicPaths.getPathValue "$userscripts" + "\\GoMax\\")
global GoMaxfoldertemp = (symbolicPaths.getPathValue "$userscripts" + "\\GoMax_installation\\")


	fn check_version= --return which version the user has, 11000 = max2009, 12000 = max 2010
	(
		ver = maxversion()
		return ver[1]
	)


rollout PickZBdir "GoMax Installation" 
(
	local bannerbmp = bitmap 100 100 --color:red
	imgtag bannerimg "imgtag" bitmap:bannerbmp width:240 height:40 pos:[0,0]
	label instructions_gomax "Pick your ZBrush 3.5 R3 root folder" align:#left pos:[40,42]
	edittext target_dir text:maxFilePath  readOnly:true across:2 width:200 pos:[0,60]
	button pick_dir "..." tooltip:"Pick ZBrush's root folder" pos:[205,59]
	button install_gomax "Install" width:100 across:2
	button uninstall_gomax "Uninstall" width:100 tooltip:"Not implemented yet"


	on PickZBdir open do(
		if doesFileExist "$userscripts\\GoMax_settings.ini" do
		(
			bannerimg.bitmap = (openBitmap "$userscripts\\GoMax_installation\\gomax_banner.bmp")
			fSettingsFile = "$userscripts\\GoMax_settings.ini"
			zBrushPath = getINISetting fSettingsFile "Zbrush" "Path" as string
			target_dir.text = (zBrushPath)
		)
	)
			
	
	
	on pick_dir pressed do
	(
		if( p = ( getsavepath initialdir:target_dir.text ) ) != undefined do
		(
			target_dir.text = p + "\\"
			zbrushDir = target_dir.text
		)
	)
	
	
	
	on install_gomax pressed do
	(
		local fSettingsFile = "$userscripts\\GoMax_settings.ini"
		global GoMaxfolder = (symbolicPaths.getPathValue "$userscripts" + "\\GoMax\\")
		version_gomax = "2.1"
		setINISetting fSettingsFile "GoMax" "Version" version_gomax
		
		if doesFileExist (target_dir.text + "ZBrush.exe") then (
			--Creates ini file with Zbrush path after checking if ZBrush.exe exists
			setINISetting fSettingsFile "Zbrush" "Path" (target_dir.text as string)
			
			
			--------------------------------------------------------------------------------------------
			--OLD FILES
			--------------------------------------------------------------------------------------------			
			
			--delete files from older installations
			for f in getFiles ("$userscripts\\GoMax\\*.*") do deleteFile f --Cleans up all the files in the GoMax folder
			for f in getFiles ("$userscripts\\GoMax\\Material\\*.*") do deleteFile f --Cleans up all the files in the GoMax\Material folder
			for f in getFiles ("$userscripts\\GoMax\\Settings\\*.*") do deleteFile f --Cleans up all the files in the GoMax\Material folder
			deleteFile ("$userscripts\\GoMax_zbrush_path.ini")
			deleteFile (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax.txt")
			deleteFile (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax.zsc")
			
			
			--------------------------------------------------------------------------------------------
			--ZBRUSH
			--------------------------------------------------------------------------------------------
			
			--Creates folders inside ZPlugs
			makeDir (target_dir.text + "\ZStartup\ZPlugs\GoMax")
			makeDir (target_dir.text + "\ZStartup\ZPlugs\GoMax\Bitmaps")
			makeDir (target_dir.text + "\ZStartup\ZPlugs\GoMax\Export")
			makeDir (target_dir.text + "\ZStartup\ZPlugs\GoMax\Import")
			makeDir (target_dir.text + "\ZStartup\ZPlugs\GoMax\Matcaps")
			makeDir (target_dir.text + "\ZStartup\ZPlugs\GoMax\Material")
			makeDir (target_dir.text + "\ZStartup\ZPlugs\GoMax\Settings")
			
			--Moves files to Zplugs folder
			deleteFile (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\Material\MATCAPSPHERE.ZTL")
			renameFile ("$userscripts\\GoMax_installation\\MATCAPSPHERE.ZTL") (target_dir.text + "\ZStartup\ZPlugs\GoMax\Material\MATCAPSPHERE.ZTL")
			deleteFile (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\gomax_new_subtool.obj")
			renameFile ("$userscripts\\GoMax_installation\\gomax_new_subtool.obj") (target_dir.text + "\ZStartup\ZPlugs\GoMax\gomax_new_subtool.obj")
					
			--Creates folder inside Macros
			makeDir (target_dir.text + "\ZStartup\Macros\GoMAX")
			
			--Moves files to Macros folder
			
			deleteFile (((target_dir.text) as string) + "\ZStartup\Macros\GoMAX\GoMAX_Export.txt")
			deleteFile (((target_dir.text) as string) + "\ZStartup\Macros\GoMAX\GoMAX_Import.txt")
			renameFile ("$userscripts\\GoMax_installation\\GoMAX_Export.txt") (target_dir.text + "\ZStartup\Macros\GoMAX\GoMAX_Export.txt")
			renameFile ("$userscripts\\GoMax_installation\\GoMAX_Import.txt") (target_dir.text + "\ZStartup\Macros\GoMAX\GoMAX_Import.txt")
			--Deletes these files just in case, from previous release. They will be created again once Zbrush is launched for the first time
			deleteFile (((target_dir.text) as string) + "\ZStartup\Macros\GoMAX\GoMax_Export.zsc")
			deleteFile (((target_dir.text) as string) + "\ZStartup\Macros\GoMAX\GoMax_Import.zsc")
			
			--------------------------------------------------------------------------------------------
			--GoMax userscript folder
			--------------------------------------------------------------------------------------------
			makeDir "$userscripts\\GoMax\\"
			makeDir "$userscripts\\GoMax\\Material\\"
			makeDir "$userscripts\\GoMax\\Settings\\"
			deleteFile ("$userscripts\\startup\\GoMaxUpdate.ms")
			renameFile ("$userscripts\\GoMax_installation\\GoMaxUpdate.ms") ("$userscripts\\startup\\GoMaxUpdate.ms")
			renameFile ("$userscripts\\GoMax_installation\\GoMax.ms") ("$userscripts\\GoMax\\GoMax.ms")
			renameFile ("$userscripts\\GoMax_installation\\GoMaxSettings.ms") ("$userscripts\\GoMax\\GoMaxSettings.ms")
			renameFile ("$userscripts\\GoMax_installation\\GoMaxZbrushExport.ms") ("$userscripts\\GoMax\\GoMaxZbrushExport.ms")
			renameFile ("$userscripts\\GoMax_installation\\GoMaxZbrushImport.ms") ("$userscripts\\GoMax\\GoMaxZbrushImport.ms")
			renameFile ("$userscripts\\GoMax_installation\\nircmdc.exe") ("$userscripts\\GoMax\\nircmdc.exe")
			renameFile ("$userscripts\\GoMax_installation\\httpget.exe") ("$userscripts\\GoMax\\httpget.exe")
			renameFile ("$userscripts\\GoMax_installation\\GoMax_Settings.bmp") ("$userscripts\\GoMax\\GoMax_Settings.bmp")
			renameFile ("$userscripts\\GoMax_installation\\launch_Zbrush.bmp") ("$userscripts\\GoMax\\launch_Zbrush.bmp")
			renameFile ("$userscripts\\GoMax_installation\\matcap_folder.bmp") ("$userscripts\\GoMax\\matcap_folder.bmp")
			renameFile ("$userscripts\\GoMax_installation\\GoMaxpinbutton.bmp") ("$userscripts\\GoMax\\GoMaxpinbutton.bmp")
			renameFile ("$userscripts\\GoMax_installation\\max_to_zb.bmp") ("$userscripts\\GoMax\\max_to_zb.bmp")
			renameFile ("$userscripts\\GoMax_installation\\zb_to_max.bmp") ("$userscripts\\GoMax\\zb_to_max.bmp")
			renameFile ("$userscripts\\GoMax_installation\\FreshInstall.txt") ("$userscripts\\GoMax\\FreshInstall.txt")
			renameFile ("$userscripts\\GoMax_installation\\mgto_technique_nm_057.FX") ("$userscripts\\GoMax\\Material\\mgto_technique_nm_057.FX")

			--These files are needed for version above 3ds Max 9
			if ((maxVersion())[1] == 9000 ) do
			(
			renameFile ("$userscripts\\GoMax_installation\\MAX_TO_ZB.bat") ("$userscripts\\GoMax\\MAX_TO_ZB.bat")
			renameFile ("$userscripts\\GoMax_installation\\ZB_TO_MAX.bat") ("$userscripts\\GoMax\\ZB_TO_MAX.bat")
			)
			
			

			--------------------------------------------------------------------------------------------
			--REMOVE TEMP INSTALL FOLDER
			--------------------------------------------------------------------------------------------
			for f in getFiles ("$userscripts\\GoMax_installation\\*.*") do deleteFile f
			ver = check_version()
			if ver > 9000  then
				(
					hiddenDosCommand ("rmDir " + "\"" + GoMaxfoldertemp + "\"" + " /s /q")
				)
				else
				(
					DosCommand ("rmDir " + "\"" + GoMaxfoldertemp + "\"" + " /s /q")
				)
			
			
			
			fileIn "$userscripts\\GoMax\\GoMax.ms"
			destroyDialog PickZBdir
			
			if ((maxVersion())[1] >= 9000 )do
			(
				colorman.reInitIcons()
			)
			--Closes installation
			destroyDialog PickZBdir

		)else(
			messagebox "No Zbrush.exe found in this folder, this is not the Zbrush 3.5 R3 root folder.")
			

	)
	
	on uninstall_gomax pressed do
	(
		if doesFileExist (target_dir.text + "ZBrush.exe") then
		(
			ver = check_version()
			for f in getFiles ("$userscripts\\GoMax\\*.*") do deleteFile f
			for f in getFiles ("$userscripts\\GoMax\\Material\\*.*") do deleteFile f
			for f in getFiles ("$userscripts\\GoMax\\Settings\\*.*") do deleteFile f
			for f in getFiles ("$userscripts\\GoMax_installation\\*.*") do deleteFile f
			for f in getFiles (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\Settings\*.*") do deleteFile f
			for f in getFiles (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\Import\*.*") do deleteFile f
			if ver > 9000  then
				(
					hiddenDosCommand ("rmDir " + "\"" + (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\Import") + "\"" + " /s /q")
					hiddenDosCommand ("rmDir " + "\"" + (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\Settings") + "\"" + " /s /q")
					hiddenDosCommand ("rmDir " + "\"" + (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\Export") + "\"" + " /s /q")
					hiddenDosCommand ("rmDir " + "\"" + (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\Material") + "\"" + " /s /q")
				)
				else
				(
					DosCommand ("rmDir " + "\"" + (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\Import") + "\"" + " /s /q")
					DosCommand ("rmDir " + "\"" + (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\Settings") + "\"" + " /s /q")
					DosCommand ("rmDir " + "\"" + (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\Export") + "\"" + " /s /q")
					DosCommand ("rmDir " + "\"" + (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\Material") + "\"" + " /s /q")
				)
					

			deleteFile (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax.txt")
			deleteFile (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax.zsc")
			deleteFile (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\gomax_new_subtool.obj")
			deleteFile (((target_dir.text) as string) + "\ZStartup\ZPlugs\GoMax\Material\MATCAPSPHERE.ZTL")
			deleteFile (((target_dir.text) as string) + "\ZStartup\Macros\GoMAX\GoMAX_Export.txt")
			deleteFile (((target_dir.text) as string) + "\ZStartup\Macros\GoMAX\GoMAX_Import.txt")
			deleteFile (((target_dir.text) as string) + "\ZStartup\Macros\GoMAX\GoMax_Export.zsc")
			deleteFile (((target_dir.text) as string) + "\ZStartup\Macros\GoMAX\GoMax_Import.zsc")
			if ver > 9000  then
				(
					hiddenDosCommand ("rmDir " + "\"" + GoMaxfolder + "\"" + " /s /q")
					hiddenDosCommand ("rmDir " + "\"" + GoMaxfoldertemp + "\"" + " /s /q")
					hiddenDosCommand ("rmDir " + "\"" + (((target_dir.text) as string) + "\ZStartup\Macros\GoMAX") + "\"" + " /s /q")
				)
				else
				(
					DosCommand ("rmDir " + "\"" + GoMaxfolder + "\"" + " /s /q")
					DosCommand ("rmDir " + "\"" + GoMaxfoldertemp + "\"" + " /s /q")
					DosCommand ("rmDir " + "\"" + (((target_dir.text) as string) + "\ZStartup\Macros\GoMAX") + "\"" + " /s /q")
				)
				
			shellLaunch "explorer.exe" (((target_dir.text) as string) + "ZStartup\\ZPlugs\\GoMax\\")
			try (--close if possible
				DestroyDialog PickZBdir;
			) catch();

			try (--close if possible
				DestroyDialog gomax_install_results;
			) catch();
		)else
		(
			messagebox "something went wrong"
		)
	)
	

)
createDialog PickZBdir width:240 height:115